SystemOrganization addCategory: #PPR2K7_TPI1_Alfonzo_Belloti_Ochoa_Ruiz!

Object subclass: #Cliente
	instanceVariableNames: 'apellido nombre numDni cuenta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PPR2K7_TPI1_Alfonzo_Belloti_Ochoa_Ruiz'!

!Cliente commentStamp: '<historical>' prior: 0!
A Cliente is xxxxxxxxx.

Instance Variables
	apellido:		<Object>
	cuenta:		<Object>
	nombre:		<Object>
	numDni:		<Object>

apellido
	- xxxxx

cuenta
	- xxxxx

nombre
	- xxxxx

numDni
	- xxxxx
!

!Cliente methodsFor: 'accessing' stamp: 'GDR 4/27/2015 10:40'!
apellido
	
	^ apellido! !

!Cliente methodsFor: 'accessing' stamp: 'GDR 4/27/2015 10:42'!
apellido: anObject
	"valida que el colaborador sea de tipo string para luego asignarlo al atributo"
	(anObject isString) ifTrue: [ apellido := anObject. ]
	! !

!Cliente methodsFor: 'accessing' stamp: 'GDR 5/2/2015 12:47'!
asString
	"Muestra los datos de un cliente"
	^ 'Nombre: ', self nombre, String cr, 'Apellido: ', self apellido, String cr, 'DNI: ', self numDni asString, String cr, 'Cuenta: ', String cr, self cuenta asString.! !

!Cliente methodsFor: 'accessing' stamp: 'GDR 5/1/2015 11:16'!
cuenta
	
	^ cuenta! !

!Cliente methodsFor: 'accessing' stamp: 'GDR 5/2/2015 19:35'!
cuenta: anObject
	"Valida que el colaborador sea de tipo cuenta y lo asigna al atributo"
	(anObject isKindOf: Cuenta) | (anObject = nil) ifTrue:[cuenta := anObject.]! !

!Cliente methodsFor: 'initialize' stamp: 'GDR 5/1/2015 11:17'!
initialize
	"Inicializa los datos de un cliente en forma predeterminada"
	super initialize.

	apellido := ''.
	nombre := ''.
	numDni := -1.
	cuenta := nil.! !

!Cliente methodsFor: 'accessing' stamp: 'GDR 4/27/2015 10:40'!
nombre
	
	^ nombre! !

!Cliente methodsFor: 'accessing' stamp: 'GDR 4/27/2015 10:44'!
nombre: anObject
	"valida que el colaborador sea de tipo string para luego asignarlo al atributo"
	(anObject isString) ifTrue: [ nombre := anObject. ]
	! !

!Cliente methodsFor: 'accessing' stamp: 'GDR 4/27/2015 10:40'!
numDni
	
	^ numDni! !

!Cliente methodsFor: 'accessing' stamp: 'GDR 5/1/2015 20:14'!
numDni: anObject
	"valida que el colaborador sea de tipo numerico y lo asigna al atributo"
	(anObject isNumber) ifTrue: [ numDni := anObject. ].! !

Object subclass: #Cuenta
	instanceVariableNames: 'estado fechaFin fechaInicio horaFin horaInicio numCuenta saldo operacionCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PPR2K7_TPI1_Alfonzo_Belloti_Ochoa_Ruiz'!

!Cuenta commentStamp: '<historical>' prior: 0!
A Cuenta is xxxxxxxxx.

Instance Variables
	estado:		<Object>
	fechaFin:		<Object>
	fechaInicio:		<Object>
	horaFin:		<Object>
	horaInicio:		<Object>
	numCuenta:		<Object>
	operacionCollection:		<Object>
	saldo:		<Object>

estado
	- xxxxx

fechaFin
	- xxxxx

fechaInicio
	- xxxxx

horaFin
	- xxxxx

horaInicio
	- xxxxx

numCuenta
	- xxxxx

operacionCollection
	- xxxxx

saldo
	- xxxxx
!

!Cuenta methodsFor: 'negocio' stamp: 'GDR 5/2/2015 18:50'!
actualizarSaldo: anObject
	"Actualiza el saldo de la cuenta segun la Operacion que se haya realizado"
	(anObject isKindOf: Operacion) ifTrue: [ self saldo: (saldo + anObject puntajePorActualizar). ].
	^ self saldo.! !

!Cuenta methodsFor: 'negocio' stamp: 'GDR 5/2/2015 12:26'!
addOperacion:anObject 
	"Valida si el colaborador es de tipo Operacion y permite agregarlo a la coleccion"
	(anObject isKindOf: Operacion) ifTrue: [operacionCollection add: anObject.].
																		       ! !

!Cuenta methodsFor: 'negocio' stamp: 'GDR 5/2/2015 13:48'!
asListado
	"Muestra todas las operaciones de una cuenta"
	|listado|
	listado:=''.
	self operacionCollection do: [ :x | listado:= listado, String cr, x asString, String cr.].
	^ String tab, 'Operaciones: ', String cr, listado.! !

!Cuenta methodsFor: 'accessing' stamp: 'GDR 5/2/2015 13:06'!
asString
	"Muestra los datos de la cuenta"
	(self estado = 'Abierta') ifTrue:[^ 'Estado de la cuenta: ', self estado, String cr, 'Fecha Inicio: ', self fechaInicio asString,String cr, 
									'Hora Inicio: ', self horaInicio asString, String cr, 'Número de cuenta: ', self numCuenta asString, String cr, 'Saldo actual: ', 
									self saldo asString, String cr, self asListado , String cr.]
							ifFalse:[ ^ 'Estado de la cuenta: ', self estado, String cr, 'Fecha Inicio: ', self fechaInicio asString,String cr, 
									'Hora Inicio: ', self horaInicio asString, String cr, 'Número de cuenta: ', self numCuenta asString, String cr, 'Saldo actual: ', 
									self saldo asString, String cr, 'Fecha Fin: ', self fechaFin asString, String cr, 'Hora fin: ', self horaFin asString.].! !

!Cuenta methodsFor: 'negocio' stamp: 'GDR 4/27/2015 13:04'!
cantidadOperaciones
	"Retorna la cantidad de operaciones para la cuenta"
	^ operacionCollection size.! !

!Cuenta methodsFor: 'accessing' stamp: 'GDR 4/27/2015 12:36'!
estado
	
	^ estado! !

!Cuenta methodsFor: 'accessing' stamp: 'GDR 4/27/2015 12:42'!
estado: anObject
	"Valida que el colaborador sea de tipo String y lo asigna al atributo"
	(anObject isString) ifTrue: [estado := anObject.]! !

!Cuenta methodsFor: 'accessing' stamp: 'GDR 4/27/2015 12:36'!
fechaFin
	
	^ fechaFin! !

!Cuenta methodsFor: 'accessing' stamp: 'GDR 4/27/2015 12:45'!
fechaFin: anObject
	"Valida que el colaborador sea de tipo Date y lo asigna. Modifica el estado de la cuenta a Cerrada"
	(anObject isKindOf: Date) ifTrue: [fechaFin := anObject. self estado:'Cerrada'.]! !

!Cuenta methodsFor: 'accessing' stamp: 'GDR 4/27/2015 12:36'!
fechaInicio
	
	^ fechaInicio! !

!Cuenta methodsFor: 'accessing' stamp: 'GDR 4/27/2015 12:46'!
fechaInicio: anObject
	"Valida que el colaborador sea de tipo Date y lo asigna al atributo."
	(anObject isKindOf: Date) ifTrue: [fechaInicio := anObject.]! !

!Cuenta methodsFor: 'accessing' stamp: 'GDR 4/27/2015 12:36'!
horaFin
	
	^ horaFin! !

!Cuenta methodsFor: 'accessing' stamp: 'GDR 4/27/2015 12:47'!
horaFin: anObject
	"Valida que el colaborador sea de tipo Time y lo asigna al atributo"
	(anObject isKindOf: Time) ifTrue: [horaFin := anObject.]! !

!Cuenta methodsFor: 'accessing' stamp: 'GDR 4/27/2015 12:36'!
horaInicio
	
	^ horaInicio! !

!Cuenta methodsFor: 'accessing' stamp: 'GDR 4/27/2015 12:48'!
horaInicio: anObject
	"Valida que el colaborador sea de tipo Time y lo asigna al atributo"
	(anObject isKindOf: Time) ifTrue: [horaInicio := anObject.]! !

!Cuenta methodsFor: 'initialize' stamp: 'GDR 5/2/2015 12:38'!
initialize

	
	estado := 'Abierta'.
	fechaFin := nil.
	fechaInicio := Date today.
	horaFin := nil.
	horaInicio := Date today.
	numCuenta := nil.
	saldo := 0.0.
	self operacionCollection: SortedCollection new.
	self operacionCollection sort: [ :x  :y |  (x fechaInicio <= y fechaInicio)  and: (x horaInicio <= y horaInicio)].
	! !

!Cuenta methodsFor: 'accessing' stamp: 'GDR 4/27/2015 12:36'!
numCuenta
	
	^ numCuenta! !

!Cuenta methodsFor: 'accessing' stamp: 'GDR 4/27/2015 12:49'!
numCuenta: anObject
	"Valida que el colaborador sea de tipo Numerico y lo asigna al atributo"
	(anObject isNumber) ifTrue: [numCuenta := anObject.]! !

!Cuenta methodsFor: 'accessing' stamp: 'GDR 5/2/2015 12:36'!
operacionCollection
	
	^ operacionCollection! !

!Cuenta methodsFor: 'accessing' stamp: 'GDR 5/2/2015 12:36'!
operacionCollection: anObject
	
	operacionCollection := anObject! !

!Cuenta methodsFor: 'accessing' stamp: 'GDR 4/27/2015 12:36'!
saldo
	
	^ saldo! !

!Cuenta methodsFor: 'accessing' stamp: 'GDR 4/27/2015 12:50'!
saldo: anObject
	"Valida que el colaborador sea de tipo Numerico y lo asigna al atributo"
	(anObject isNumber) ifTrue: [saldo := anObject.]! !

Object subclass: #GestionCuentas
	instanceVariableNames: 'clienteCollection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PPR2K7_TPI1_Alfonzo_Belloti_Ochoa_Ruiz'!

!GestionCuentas commentStamp: '<historical>' prior: 0!
A GestionCuentas is xxxxxxxxx.

Instance Variables
	clienteCollection:		<Object>

clienteCollection
	- xxxxx
!

!GestionCuentas methodsFor: 'negocio' stamp: 'GDR 5/2/2015 00:50'!
addClienteCollection: anObject
	"1) Valida si el colaborador es de tipo Cliente y lo agrega a la coleccion" 
	(anObject isKindOf: Cliente) ifTrue: [ clienteCollection add: anObject.^'Se  agrego correctamente el cliente a la coleccion.'.]
								ifFalse: [ ^ 'Ingrese correctamente el cliente.' ].
					
	! !

!GestionCuentas methodsFor: 'negocio' stamp: 'GDR 5/2/2015 16:46'!
addCuenta:anObject cuenta:unaCuenta
	"2) Valida que el colaborador sea de tipo cliente y al mismo le crea una cuenta"
	(anObject isNumber) & (unaCuenta isKindOf: Cuenta) ifTrue: [ self clienteCollection do: [:x | (x numDni = anObject)
																ifTrue: [  (x cuenta = nil) 
																	ifTrue:[ x cuenta: unaCuenta. ^ String tab, 'Se creo correctamente la cuenta'.].].].]
														ifFalse: [^'Ingrese correctamente los datos del cliente o la cuenta'].
	! !

!GestionCuentas methodsFor: 'accessing' stamp: 'GDR 5/2/2015 13:47'!
asString
	"Muestra los datos de los clientes de la gestion de cuentas"
	|listado|
	listado := ''.
	( clienteCollection isNotEmpty) ifTrue: [clienteCollection do: [ :x | listado := listado, String cr, String tab, 'Cliente: ', String cr, x asString. ].]
								ifFalse: [ ^ String cr, 'No existen clientes.'. ].
	^ 'Estos son los clientes: ', String cr, listado.! !

!GestionCuentas methodsFor: 'negocio' stamp: 'GDR 5/2/2015 17:40'!
canjearCuenta:anObject cliente:unCliente operacion:unCanje premio:unPremio
	"6) Registra el canje para una cuenta existente y abierta de un cliente y actualiza su saldo"
	(unCanje isKindOf: Canje) & (unCliente isNumber) & (anObject isNumber) & (unPremio isNumber) ifTrue: [ ( self clienteCollection isNotEmpty)
																												 ifTrue: [ self clienteCollection do: [:x | (x numDni = unCliente) 
																													ifTrue: [(x cuenta numCuenta  = anObject) 
																														ifTrue: [(x cuenta estado = 'Abierta') 
																															ifTrue: [(x cuenta saldo >= unPremio) 																															
																																ifTrue: [ unCanje importePremio: unPremio.
																																		 x cuenta operacionCollection add: unCanje.
																																		 x cuenta actualizarSaldo: unCanje.
																																		 ^'Se registro el canje correctamente'.].]
																															ifFalse: [^ 'No hay saldo suficiente.'].]
																														ifFalse: [^'La cuenta esta Cerrada'.].]
																													ifFalse: [^'No existe la cuenta'.].].].]
																										ifFalse: [ ^'Ingrese los datos correctamente'.].

	! !

!GestionCuentas methodsFor: 'negocio' stamp: 'GDR 5/2/2015 18:33'!
cantidadDeCanjes:anObject cliente:unCliente
	"13) Retorna la cantidad de canjes realizados en una cuenta por un determinado cliente"
	|aux|
	aux:=0.
	(unCliente isNumber) & (anObject isNumber ) ifTrue: [( self clienteCollection isNotEmpty )
															 ifTrue: [ self clienteCollection do: [:x | (x numDni = unCliente) 
																ifTrue: [ (x cuenta numCuenta = anObject ) 
																	ifTrue: [ x cuenta operacionCollection do: [:y | (y isKindOf: Canje) 
																		ifTrue:[aux:= aux + 1].].]
																ifFalse: [ ^'El numero de cuenta no pertenece a este cliente.', String tab, unCliente asString.].].].].]   
											 ifFalse: [ ^'Ingrese solo numeros'.].
	^ 'La cantidad de canjes exitosos es de: ', String tab, aux asString. 
			
	
! !

!GestionCuentas methodsFor: 'accessing' stamp: 'GDR 5/1/2015 21:33'!
clienteCollection
	
	^ clienteCollection! !

!GestionCuentas methodsFor: 'accessing' stamp: 'GDR 5/2/2015 12:48'!
clienteCollection: anObject
	
	clienteCollection := anObject! !

!GestionCuentas methodsFor: 'negocio' stamp: 'GDR 5/2/2015 18:41'!
clientesSupermercado:anObject 
	"15) Muestra los datos de todos los clientes que tengan un saldo superior al valor de un colaborador"
	|listado|
	listado:=''.
	(anObject isNumber) ifTrue: [ ( clienteCollection isNotEmpty) ifTrue: [  clienteCollection do: [ :x | (x cuenta saldo > anObject) "ver si es do o select"
																			ifTrue: [listado:= listado, String cr, x asString].].].]
						  ifFalse:[^'Ingrese el saldo correctamente'.].
	(listado size ~= 0) ifTrue: [^ String cr, 'Estos son los clientes que cumplen la condicion: ', listado.]
		ifFalse: [ ^ 'No hay clientes que cumplan la condicion'. ]! !

!GestionCuentas methodsFor: 'negocio' stamp: 'GDR 5/2/2015 16:37'!
closeCuenta:anObject cliente:unCliente
	"3) Cierra una cuenta si existe un cliente y si el mismo tiene una cuenta abierta asociada"
	(unCliente isNumber) & (anObject isNumber) ifTrue: [(self clienteCollection isNotEmpty) 
													ifTrue: [self clienteCollection do: [:x | (x numDni = unCliente) 
														ifTrue: [ (x cuenta numCuenta = anObject) 
															ifTrue: [x cuenta estado: 'Cerrada'; fechaFin: Date today; horaFin: Time nowLocal. 
																      ^String cr, 'La cuenta se cerro correctamente.', String cr, x asString]
															ifFalse: [^'No existe el numero de cuenta ingresado:', String tab, anObject  asString.].]
													     " ifFalse: [^'No existe el cliente: ', String tab, unCliente asString.]".].]  "Si comentamos esta linea el metodo funciona sin problemas, sino siempre retorna esto"
													ifFalse: [^'No hay ningun cliente registrado.'.].]	
												ifFalse: [ ^ 'Ingrese numeros.' .].										
												  	! !

!GestionCuentas methodsFor: 'negocio' stamp: 'GDR 5/2/2015 18:52'!
comprarCuenta:anObject cliente:unCliente operacion:unaCompra importe:unImporte
	"5) Registra la compra para una cuenta existente y abierta de un cliente"
	(unCliente isNumber) & (unaCompra isKindOf: Compra) & (anObject isNumber ) & (unImporte isNumber) & (unImporte >0) ifTrue: [(clienteCollection isNotEmpty) 
																																				ifTrue: [clienteCollection do: [:x | (x numDni = unCliente) 
																																					ifTrue: [(x cuenta numCuenta = anObject) 
																																						ifTrue: [(x cuenta estado = 'Abierta') 
																																							ifTrue: [unaCompra importeTotalFacturado: unImporte.
																																								      x cuenta operacionCollection add: unaCompra.
																																								      x cuenta actualizarSaldo: unaCompra.
																																								      ^'La compra se registro correctamente.', x asString].]
																																				      ifFalse: [^'No existe la cuenta.'].].].].]
																																ifFalse: [^'Ingrese los datos correctamente.'.]. ! !

!GestionCuentas methodsFor: 'negocio' stamp: 'GDR 5/2/2015 19:14'!
comprasPorCliente:anObject cliente:unCliente
	"9) Devuelve la cantidad de compras realizadas por un cliente"
	|aux|
	aux:=0.
	(unCliente isNumber) & (anObject isNumber) ifTrue: [( self clienteCollection isNotEmpty) 
																	ifTrue: [ self clienteCollection do: [:x | (x numDni = unCliente) 
																		ifTrue: 	[(x cuenta numCuenta = anObject)
																	 		ifTrue: [x cuenta operacionCollection do: [ :y | (y isKindOf: Compra) ifTrue: [aux:= aux + 1].].]
																		ifFalse: [^'No existe la cuenta'.].]
																	ifFalse: [^'No existe el cliente: ', unCliente asString.].].].]
												  ifFalse: [ ^'Ingrese solo numeros'.].
	(aux > 0) ifTrue: [^'La cantidad total de compras es de: ', aux asString.]
			  ifFalse: [ ^ 'No exiten compras para este cliente'. ]! !

!GestionCuentas methodsFor: 'negocio' stamp: 'GDR 5/2/2015 19:23'!
eliminarCliente:anObject 	
	"16) Elimina un cliente si su cuenta esta cerrado, sino pide confirmacion para hacerlo"
	(anObject isNumber) ifTrue: [ self clienteCollection do: [ :x | (x numDni = anObject)
								 ifTrue: [ (x cuenta estado ~= 'Abierta')
									 ifTrue: [ self clienteCollection remove: x. ^'El cliente se elimino correctamente.', self asString].].].]
								"ifFalse: [^'El cliente posee una cuenta Abierta, ¿desea eliminarlo?']"
						  ifFalse: [ ^ 'Ingrese un numero.'. ]! !

!GestionCuentas methodsFor: 'negocio' stamp: 'GDR 5/2/2015 19:46'!
eliminarCuenta:anObject cliente:unCliente
	"4) Elimina definitivamente una cuenta si esta existe y si la misma esta asociada a un cliente"
	(unCliente isNumber ) & (anObject isNumber) ifTrue: [( self clienteCollection isNotEmpty ) 
													ifTrue: [ self clienteCollection do: [:x | (x numDni = unCliente) 
														 ifTrue: [(x cuenta numCuenta = anObject) 
																ifTrue: [ (x cuenta estado = 'Cerrada') 
																	ifTrue: [x cuenta: nil. ^'Se elimino correctamente la cuenta.', String cr, x asString]
																	ifFalse: [^ 'La cuenta sigue Abierta. ¿Desea cerrarla?'].]
																ifFalse: [^'El numero de cuenta no coincide.', String tab, anObject asString.].]
															" ifFalse: [^ 'No existe el cliente: ', String tab, unCliente asString.]".].].]
												ifFalse: [ ^ 'Ingrese numeros.'. ].
! !

!GestionCuentas methodsFor: 'negocio' stamp: 'GDR 5/2/2015 19:55'!
importeCliente:anObject cliente:unCliente
	"10) Devuelve el importe total de todas las compras realizadas por un cliente"
	|aux|
	aux:=0.0.
	(unCliente isNumber) & (anObject isNumber) ifTrue: [( self clienteCollection isNotEmpty)
		 														ifTrue: [self clienteCollection do: [:x | (x numDni = unCliente)
																		 ifTrue: [(x cuenta numCuenta = anObject)
																			 ifTrue: [ x cuenta operacionCollection do: [ :y | (y isKindOf: Compra)
																																ifTrue: [aux:= (aux + y importeTotalFacturado) .].].].].].].]
												    ifFalse: [^'Ingrese los datos correctamente.'].
	^ 'El importe total facturado es de: ', aux asString.! !

!GestionCuentas methodsFor: 'initialize' stamp: 'GDR 5/2/2015 12:52'!
initialize
	"Crea una coleccion y le asigna una condicion para agregar en la misma"
	
	self clienteCollection: SortedCollection new.
	self clienteCollection sortBlock: [ :x :y | (x apellido <= y apellido) & (x nombre <= y nombre)].! !

!GestionCuentas methodsFor: 'negocio' stamp: 'GDR 5/2/2015 20:34'!
operacionCuenta:anObject cliente:unCliente desde:unDesde hasta:unHasta
	"8) Muestra los datos de las operaciones de forma descendente que existan en un periodo"
	|listado|
	listado:=''.
	(unDesde isKindOf: Date) &(unHasta isKindOf: Date) & (unCliente isNumber) & (anObject isNumber)
	 ifTrue: [( self clienteCollection isNotEmpty)
		 ifTrue: [self clienteCollection do: [:x | (x numDni = unCliente) 
												ifTrue: [(x cuenta numCuenta = anObject) 
															ifTrue: [(x cuenta operacionCollection isNotEmpty) 
																				ifTrue: [x cuenta operacionCollection do: [:y | (y fechaInicio >= unDesde) & (y fechaInicio <=unHasta) 
																																			ifTrue: [listado := listado, String cr, y asString, String cr.].].].].].].].]
	ifFalse: [^'Ingrese los datos correctamente'.].
	(listado size > 0) ifTrue: [ ^String cr, 'Las operaciones son las siguientes: ', String cr, listado.]
					   ifFalse: [ ^ 'El cliente o la cuenta no existen o no se encuentran operaciones entre las fechas ingresadas' ]! !

!GestionCuentas methodsFor: 'negocio' stamp: 'GDR 5/2/2015 20:45'!
operacionCuenta:anObject cliente:unCliente puntaje:unPuntaje
	"14) Muestra los datos de las operaciones de una cuenta de un cliente que superen un cierto puntaje"
	|listado|
	listado:=''.
	(unPuntaje isNumber) & (unCliente isNumber) & (anObject isNumber) 
	ifTrue: [(self clienteCollection isNotEmpty)
					ifTrue: [self clienteCollection do: [:x | (x numDni = unCliente) 
															ifTrue: [ (x cuenta numCuenta = anObject) & (x cuenta estado = 'Abierta')
																					ifTrue: [x cuenta operacionCollection do: [ :y | (y puntajePorActualizar > unPuntaje)
																																		ifTrue: [listado:= listado, String cr, y asString, String cr.].].].].].].]
																						
	ifFalse: [^'Ingrese los datos correctamente'.].
	(listado size >0) ifTrue: [^ 'Los datos de las operaciones son: ', String cr, listado.]
					  ifFalse: [ ^ 'No existen operaciones que cumplan con el criterio.' ]! !

!GestionCuentas methodsFor: 'negocio' stamp: 'GDR 5/3/2015 14:39'!
porcentajeCuentasCerradas
	"11) Devuelve el porcentaje de clientes cuyas cuentas han sido cerradas"
	|aux porcentaje|
	aux:=0.
	porcentaje:=0.0.
	
	 self clienteCollection do: [ :x |  (x cuenta ~= nil) ifTrue: [ (x cuenta estado  = 'Cerrada') ifTrue: [ aux:= aux + 1].].].
	porcentaje := aux / self clienteCollection size * 100.
	
	(porcentaje ~= 0) ifTrue: [^ 'El porcentaje de clientes con cuentas cerradas es: ', porcentaje asString, '%.'.];
					    ifFalse: [ ^ 'No existen cuentas cerradas.', String cr , self asString.]
					
	 ! !

!GestionCuentas methodsFor: 'negocio' stamp: 'GDR 5/2/2015 21:32'!
saldoPromedio
	"7) Calcula el saldo promedio de puntos de todas las cuentas de puntos"
	|acu promedio total|
	acu:=0.0.
	promedio:=0.0.
	total := 0.	 
	(self clienteCollection isNotEmpty) ifTrue: [ self clienteCollection do: [:x | (x cuenta ~= nil) ifTrue: [acu := acu + x cuenta saldo. total := total +1.].].].
	promedio:= acu / total.
	^ 'El saldo promedio de puntos es: ', promedio asString, String tab, 'entre un total de ', total asString, ' cuentas.'.! !

!GestionCuentas methodsFor: 'negocio' stamp: 'GDR 5/2/2015 21:39'!
saldoTotal: anObject
	"13) Calcula el saldo total de punto entre todas las cuentas de puntos cuyo puntaje sea superior a un colaborador"
	|saldoTotal|
	saldoTotal:=0.0.
	(anObject isNumber) ifTrue: [ self clienteCollection do: [ :x | (x cuenta ~= nil)
																	ifTrue: [ (x cuenta cantidadOperaciones > anObject)
																			ifTrue: [ saldoTotal := saldoTotal + x cuenta saldo.].].].]
						ifFalse: [^'Ingrese la cantidad de operaciones de forma correcta.'.].
	
	(saldoTotal > 0) ifTrue: [^ 'El saldo total de puntos es: ',saldoTotal asString.]
					ifFalse: [ ^ 'No existen cuentas con esa cantidad de operaciones.' ]! !

Object subclass: #Operacion
	instanceVariableNames: 'fechaInicio horaInicio nombre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PPR2K7_TPI1_Alfonzo_Belloti_Ochoa_Ruiz'!

!Operacion commentStamp: '<historical>' prior: 0!
An Operacion is xxxxxxxxx.

Instance Variables
	fechaInicio:		<Object>
	horaInicio:		<Object>
	nombre:		<Object>

fechaInicio
	- xxxxx

horaInicio
	- xxxxx

nombre
	- xxxxx
!

Operacion subclass: #Canje
	instanceVariableNames: 'importePremio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PPR2K7_TPI1_Alfonzo_Belloti_Ochoa_Ruiz'!

!Canje commentStamp: '<historical>' prior: 0!
A Canje is xxxxxxxxx.

Instance Variables
	importePremio:		<Object>

importePremio
	- xxxxx
!

!Canje methodsFor: 'accessing' stamp: 'GDR 5/2/2015 13:17'!
asString
	"Llama al metodo asString de Operacion y agrega los datos de la clase"
	^ super asString, String cr, 'El importe es: ', self importePremio asString.
	

	! !

!Canje methodsFor: 'accessing' stamp: 'GDR 4/27/2015 11:39'!
importePremio
	
	^ importePremio! !

!Canje methodsFor: 'accessing' stamp: 'GDR 4/27/2015 11:40'!
importePremio: anObject
	"Valida que el colaborador sea de tipo numerico y lo asigna al atributo"
	(anObject isNumber) ifTrue: [importePremio := anObject.]! !

!Canje methodsFor: 'initialize' stamp: 'GDR 5/1/2015 11:11'!
initialize

	super initialize.

	importePremio := 0.
	! !

!Canje methodsFor: 'negocio' stamp: 'GDR 4/27/2015 12:03'!
puntajePorActualizar
	"Llama al metodo puntajePoractualizar de la clase Operacion, metodo abstracto"
	super puntajePorActualizar! !

Canje subclass: #Envio
	instanceVariableNames: 'importeEnvio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PPR2K7_TPI1_Alfonzo_Belloti_Ochoa_Ruiz'!

!Envio commentStamp: '<historical>' prior: 0!
An Envio is xxxxxxxxx.

Instance Variables
	importeEnvio:		<Object>

importeEnvio
	- xxxxx
!

!Envio methodsFor: 'accessing' stamp: 'GDR 5/2/2015 19:50'!
asString
	"Llama al metodo asString de la clase Canje y agrega los datos propios"
	^ super asString, String cr, 'El importe del envio: ', self importeEnvio asString, String cr, 'Costo del canje: ', self puntajePorActualizar asString.
	! !

!Envio methodsFor: 'accessing' stamp: 'GDR 4/27/2015 11:46'!
importeEnvio
	
	^ importeEnvio! !

!Envio methodsFor: 'accessing' stamp: 'GDR 4/27/2015 11:48'!
importeEnvio: anObject
	"Valida que el colaborador sea de tipo numerico y positivo y lo asigna al atributo"
	(anObject isNumber) & (anObject >0) ifTrue: [importeEnvio := anObject.]! !

!Envio methodsFor: 'initialize' stamp: 'GDR 4/27/2015 12:09'!
initialize

	super initialize.

	importeEnvio := 0.
	super nombre: 'Envio'.! !

!Envio methodsFor: 'negocio' stamp: 'GDR 5/2/2015 00:37'!
puntajePorActualizar
	"Redefine el metodo puntajePorActualizar"
	^ ((importePremio * 2) + (importeEnvio * 2 ) )* -1.! !

Canje subclass: #Inmediata
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PPR2K7_TPI1_Alfonzo_Belloti_Ochoa_Ruiz'!

!Inmediata commentStamp: '<historical>' prior: 0!
An Inmediata is xxxxxxxxx.
!

!Inmediata methodsFor: 'accessing' stamp: 'GDR 5/2/2015 19:50'!
asString
	"Llama al metodo asString de la clase Canje"
	^ super asString, String cr, 'Costo del canje: ', self puntajePorActualizar asString.! !

!Inmediata methodsFor: 'initialize' stamp: 'GDR 4/27/2015 12:09'!
initialize

	super initialize.
	super nombre: 'Entrega Inmediata'.
! !

!Inmediata methodsFor: 'negocio' stamp: 'GDR 4/27/2015 11:55'!
puntajePorActualizar
	"Redefine el metodo puntajePorActualizar de la clase Canje"
	^ importePremio * -2
	! !

Operacion subclass: #Compra
	instanceVariableNames: 'importeTotalFacturado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PPR2K7_TPI1_Alfonzo_Belloti_Ochoa_Ruiz'!

!Compra commentStamp: '<historical>' prior: 0!
A Compra is xxxxxxxxx.

Instance Variables
	importeTotalFacturado:		<Object>

importeTotalFacturado
	- xxxxx
!

!Compra methodsFor: 'accessing' stamp: 'GDR 5/2/2015 18:56'!
asString
	"Llama al metodo asString de la clase Operacion y agrega datos"
	^ super asString, String cr, 'El importe total facturado: ', self importeTotalFacturado asString.! !

!Compra methodsFor: 'accessing' stamp: 'GDR 4/27/2015 11:58'!
importeTotalFacturado
	
	^ importeTotalFacturado! !

!Compra methodsFor: 'accessing' stamp: 'GDR 4/27/2015 12:03'!
importeTotalFacturado: anObject
	"Valida que el colaborador sea de tipo numerico y lo asigna al atributo"
	(anObject isNumber) ifTrue: [importeTotalFacturado := anObject.]! !

!Compra methodsFor: 'initialize' stamp: 'GDR 4/27/2015 12:14'!
initialize

	super initialize.

	importeTotalFacturado := 0.0.! !

!Compra methodsFor: 'negocio' stamp: 'jg 4/27/2015 23:06'!
puntajePorActualizar
	"Llama al metodo puntajePorActualizar de la clase Operacion, metodo abstracto"
	super puntajePorActualizar.! !

Compra subclass: #Debito
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PPR2K7_TPI1_Alfonzo_Belloti_Ochoa_Ruiz'!

!Debito commentStamp: '<historical>' prior: 0!
A Debito is xxxxxxxxx.
!

!Debito methodsFor: 'accessing' stamp: 'GDR 5/2/2015 18:59'!
asString
	"Llama al metodo asString de la clase Compra"
	^ super asString, String cr, 'Suma de puntos: ', self puntajePorActualizar asString.! !

!Debito methodsFor: 'initialize' stamp: 'GDR 4/27/2015 12:10'!
initialize

	super initialize.
	super nombre: 'Débito Automático'.
! !

!Debito methodsFor: 'negocio' stamp: 'GDR 4/27/2015 12:14'!
puntajePorActualizar
	"Redefine el metodo puntajePorActualizar de la clase Compra"
	^ importeTotalFacturado * 0.25.! !

Compra subclass: #Efectivo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PPR2K7_TPI1_Alfonzo_Belloti_Ochoa_Ruiz'!

!Efectivo commentStamp: '<historical>' prior: 0!
An Efectivo is xxxxxxxxx.
!

!Efectivo methodsFor: 'accessing' stamp: 'GDR 5/2/2015 19:00'!
asString
	"Llama al metodo asString de la clase Compra"
	^ super asString, String cr, 'Suma de puntos: ', self puntajePorActualizar asString.! !

!Efectivo methodsFor: 'initialize' stamp: 'GDR 4/27/2015 12:17'!
initialize

	super initialize.
	super nombre: 'Contado Efectivo'.! !

!Efectivo methodsFor: 'negocio' stamp: 'GDR 4/27/2015 12:19'!
puntajePorActualizar
	"Redefine el metodo puntajePorActualizar de la clase Compra"
	^ importeTotalFacturado * 0.5.! !

Compra subclass: #Tarjeta
	instanceVariableNames: 'cantCuotas numTarjeta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PPR2K7_TPI1_Alfonzo_Belloti_Ochoa_Ruiz'!

!Tarjeta commentStamp: '<historical>' prior: 0!
A Tarjeta is xxxxxxxxx.

Instance Variables
	cantCuotas:		<Object>
	numTarjeta:		<Object>

cantCuotas
	- xxxxx

numTarjeta
	- xxxxx
!

!Tarjeta methodsFor: 'accessing' stamp: 'GDR 5/2/2015 19:00'!
asString
	"Llama al metodo asString de la clase Compra y agrega datos propios"
	^ super asString, String cr, 'Numero de tarjeta: ', self numTarjeta asString, String cr, 'Cantidad de cuotas: ', self cantCuotas asString, String cr, 'Suma de puntos: ', self puntajePorActualizar asString.! !

!Tarjeta methodsFor: 'accessing' stamp: 'GDR 4/27/2015 12:21'!
cantCuotas
	
	^ cantCuotas! !

!Tarjeta methodsFor: 'accessing' stamp: 'GDR 4/27/2015 12:22'!
cantCuotas: anObject
	"Valida que el colaborador sea de tipo numerico y lo asigna al atributo"
	(anObject isNumber) ifTrue: [cantCuotas := anObject.]! !

!Tarjeta methodsFor: 'initialize' stamp: 'GDR 4/27/2015 12:21'!
initialize

	super initialize.

	cantCuotas := nil.
	numTarjeta := nil.
	super nombre: 'Tarjeta de Credito'.! !

!Tarjeta methodsFor: 'accessing' stamp: 'GDR 4/27/2015 12:21'!
numTarjeta
	
	^ numTarjeta! !

!Tarjeta methodsFor: 'accessing' stamp: 'GDR 4/27/2015 12:23'!
numTarjeta: anObject
	"Valida que el colaborador sea de tipo numerico y lo asigna al atributo"
	(anObject isNumber) ifTrue: [numTarjeta := anObject.]! !

!Tarjeta methodsFor: 'negocio' stamp: 'GDR 5/2/2015 18:52'!
puntajePorActualizar
	"Redefine el metodo puntajePorActualizar de la clase Compra"
	|aux|
	aux:=0.
	(cantCuotas > 6 ) ifTrue: [ aux:= (importeTotalFacturado *0.1).]
					   ifFalse: [ aux:= (importeTotalFacturado * 0.15).].
	^ aux.! !

!Operacion methodsFor: 'accessing' stamp: 'GDR 5/2/2015 00:33'!
asString
	"Muestra los datos"
	^ 'Fecha de inicio: ', self fechaInicio asString, String cr, 'Hora inicio: ', self horaInicio asString, String cr, 'Nombre: ', self nombre.! !

!Operacion methodsFor: 'accessing' stamp: 'GDR 4/27/2015 10:50'!
fechaInicio
	
	^ fechaInicio! !

!Operacion methodsFor: 'accessing' stamp: 'GDR 5/2/2015 00:34'!
fechaInicio: anObject
	"Valida que el colaborador sea de tipo fecha para luego asignarla al atributo"
	 (anObject isKindOf: Date ) ifTrue: [fechaInicio := anObject.].! !

!Operacion methodsFor: 'accessing' stamp: 'GDR 4/27/2015 10:50'!
horaInicio
	
	^ horaInicio! !

!Operacion methodsFor: 'accessing' stamp: 'GDR 4/27/2015 10:59'!
horaInicio: anObject
	"Valida que el colaborador sea de tipo hora para luego asignarla al atributo "
	(anObject isKindOf: Time) ifTrue: [ horaInicio := anObject. ] ! !

!Operacion methodsFor: 'initialize' stamp: 'GDR 5/2/2015 12:28'!
initialize

	fechaInicio := Date new .
	horaInicio := Time new.
	nombre := ''.! !

!Operacion methodsFor: 'accessing' stamp: 'GDR 4/27/2015 12:06'!
nombre
	
	^ nombre! !

!Operacion methodsFor: 'accessing' stamp: 'GDR 4/27/2015 12:08'!
nombre: anObject
	"Valida que el colaborador sea de tipo String y lo asigna al atributo"
	(anObject isString ) ifTrue: [nombre := anObject.]! !

!Operacion methodsFor: 'negocio' stamp: 'GDR 4/27/2015 11:38'!
puntajePorActualizar
	"Metodo sin cuerpo, se redefine en las clases hijas"
! !
